<?php

namespace Drupal\single_content_sync\Attribute;

use Drupal\Component\Plugin\Attribute\Plugin;
use Drupal\Core\StringTranslation\TranslatableMarkup;

/**
 * Defines a SingleContentSyncBaseFieldsProcessor attribute object.
 *
 * Plugin Namespace: Plugin\SingleContentSyncBaseFieldsProcessor.
 *
 * @see \Drupal\single_content_sync\SingleContentSyncBaseFieldsProcessorInterface
 * @see \Drupal\single_content_sync\SingleContentSyncBaseFieldsProcessorPluginManager
 * @see \Drupal\single_content_sync\SingleContentSyncBaseFieldsProcessorPluginBase
 *
 * @Annotation
 */
#[\Attribute(\Attribute::TARGET_CLASS)]
class SingleContentSyncBaseFieldsProcessor extends Plugin {

  /**
   * Constructs a SingleContentSyncBaseFieldsProcessor attribute.
   *
   * @param string $id
   *   The plugin ID.
   * @param \Drupal\Core\StringTranslation\TranslatableMarkup|null $label
   *   The administrative label of the plugin.
   * @param string|null $entity_type
   *   (optional) The entity type machine name that this plugin supports.
   * @param string|null $deriver
   *   (optional) The deriver class.
   */
  public function __construct(
    public readonly string $id,
    public readonly ?TranslatableMarkup $label = NULL,
    public readonly ?string $entity_type = NULL,
    public readonly ?string $deriver = NULL
  ) {}

}
