<?php

namespace Drupal\single_content_sync\Attribute;

use Drupal\Component\Plugin\Attribute\Plugin;
use Drupal\Core\StringTranslation\TranslatableMarkup;

/**
 * Defines a SingleContentSyncFieldProcessor attribute object.
 *
 * Plugin Namespace: Plugin\SingleContentSyncFieldProcessor.
 *
 * @see \Drupal\single_content_sync\SingleContentSyncFieldProcessorInterface
 * @see \Drupal\single_content_sync\SingleContentSyncFieldProcessorPluginManager
 * @see \Drupal\single_content_sync\SingleContentSyncFieldProcessorPluginBase
 *
 * @Annotation
 */
#[\Attribute(\Attribute::TARGET_CLASS)]
class SingleContentSyncFieldProcessor extends Plugin {

  /**
   * Constructs a SingleContentSyncFieldProcessor attribute.
   *
   * @param string $id
   *   The plugin ID.
   * @param \Drupal\Core\StringTranslation\TranslatableMarkup|null $label
   *   The administrative label of the plugin.
   * @param string|null $field_type
   *   (optional) The field type machine name that this plugin supports.
   * @param string|null $deriver
   *   (optional) The deriver class.
   */
  public function __construct(
    public readonly string $id,
    public readonly ?TranslatableMarkup $label = NULL,
    public readonly ?string $field_type = NULL,
    public readonly ?string $deriver = NULL
  ) {}

}
